#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using ProjetTheAlone.Classes;
#endregion

namespace ProjetTheAlone.Acces
{
 /// <summary>
 /// Couche d'accès aux données (Data Access Layer)
 /// </summary>
 public class A_T_typeEvenement : ADBase
 {
        string _TE_Nom;
        public string TE_Nom { get => _TE_Nom; set => _TE_Nom = value; }
        #region Constructeurs
        public A_T_typeEvenement(string sChaineConnexion)
  	: base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(string TE_nom)
  {
   CreerCommande("AjouterT_typeEvenement");
   int res = 0;
   Commande.Parameters.Add("ID_typeEvenement", SqlDbType.Int);
   Direction("ID_typeEvenement", ParameterDirection.Output);
   if(TE_nom == null) Commande.Parameters.AddWithValue("@TE_nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@TE_nom", TE_nom);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   res = int.Parse(LireParametre("ID_typeEvenement"));
   Commande.Connection.Close();
   return res;
  }
  public int Modifier(int ID_typeEvenement,string  TE_nom)
  {
   CreerCommande("ModifierT_typeEvenement");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID_typeEvenement", ID_typeEvenement);
   if(TE_nom == null) Commande.Parameters.AddWithValue("@TE_nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@TE_nom", TE_nom);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   Commande.Connection.Close();
   return res;
  }
  public List<C_T_typeEvenement> Lire(string Index)
  {
   CreerCommande("SelectionnerT_typeEvenement");
   Commande.Parameters.AddWithValue("@Index", Index);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   List<C_T_typeEvenement> res = new List<C_T_typeEvenement>();
   while (dr.Read())
   {
    C_T_typeEvenement tmp = new C_T_typeEvenement();
    tmp.ID_typeEvenement = int.Parse(dr["ID_typeEvenement"].ToString());
   if(dr["TE_nom"] != DBNull.Value) tmp.TE_nom = (dr["TE_nom"].ToString());
    res.Add(tmp);
			}
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public C_T_typeEvenement Lire_ID(int ID_typeEvenement)
  {
   CreerCommande("SelectionnerT_typeEvenement_ID");
   Commande.Parameters.AddWithValue("@ID_typeEvenement", ID_typeEvenement);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   C_T_typeEvenement res = new C_T_typeEvenement();
   while (dr.Read())
   {
    res.ID_typeEvenement = int.Parse(dr["ID_typeEvenement"].ToString());
   if(dr["TE_nom"] != DBNull.Value) res.TE_nom = (dr["TE_nom"].ToString());
   }
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public int Supprimer(int ID_typeEvenement)
  {
   CreerCommande("SupprimerT_typeEvenement");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID_typeEvenement", ID_typeEvenement);
   Commande.Connection.Open();
   res = Commande.ExecuteNonQuery();
			Commande.Connection.Close();
			return res;
		}
 }
}
