#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using ProjetTheAlone.Classes;
#endregion

namespace ProjetTheAlone.Acces
{
 /// <summary>
 /// Couche d'accès aux données (Data Access Layer)
 /// </summary>
 public class A_T_typeRepa : ADBase
 {
  #region Constructeurs
  public A_T_typeRepa(string sChaineConnexion)
  	: base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(string TR_nom)
  {
   CreerCommande("AjouterT_typeRepa");
   int res = 0;
   Commande.Parameters.Add("ID_typeRepa", SqlDbType.Int);
   Direction("ID_typeRepa", ParameterDirection.Output);
   if(TR_nom == null) Commande.Parameters.AddWithValue("@TR_nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@TR_nom", TR_nom);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   res = int.Parse(LireParametre("ID_typeRepa"));
   Commande.Connection.Close();
   return res;
  }
  public int Modifier(int ID_typeRepa, string TR_nom)
  {
   CreerCommande("ModifierT_typeRepa");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID_typeRepa", ID_typeRepa);
   if(TR_nom == null) Commande.Parameters.AddWithValue("@TR_nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@TR_nom", TR_nom);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   Commande.Connection.Close();
   return res;
  }
  public List<C_T_typeRepa> Lire(string Index)
  {
   CreerCommande("SelectionnerT_typeRepa");
   Commande.Parameters.AddWithValue("@Index", Index);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   List<C_T_typeRepa> res = new List<C_T_typeRepa>();
   while (dr.Read())
   {
    C_T_typeRepa tmp = new C_T_typeRepa();
    tmp.ID_typeRepa = int.Parse(dr["ID_typeRepa"].ToString());
    tmp.TR_nom = dr["TR_nom"].ToString();
    res.Add(tmp);
			}
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public C_T_typeRepa Lire_ID(int ID_typeRepa)
  {
   CreerCommande("SelectionnerT_typeRepa_ID");
   Commande.Parameters.AddWithValue("@ID_typeRepa", ID_typeRepa);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   C_T_typeRepa res = new C_T_typeRepa();
   while (dr.Read())
   {
    res.ID_typeRepa = int.Parse(dr["ID_typeRepa"].ToString());
    res.TR_nom = dr["TR_nom"].ToString();
   }
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public int Supprimer(int ID_typeRepa)
  {
   CreerCommande("SupprimerT_typeRepa");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID_typeRepa", ID_typeRepa);
   Commande.Connection.Open();
   res = Commande.ExecuteNonQuery();
			Commande.Connection.Close();
			return res;
		}
 }
}
