#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using ProjetTheAlone.Classes;
using ProjetTheAlone.Acces;
#endregion

namespace ProjetTheAlone.Gestion
{
 /// <summary>
 /// Couche intermédiaire de gestion (Business Layer)
 /// </summary>
 public class G_T_repa : G_Base
 {
  #region Constructeurs
  public G_T_repa()
   : base()
  { }
  public G_T_repa(string sChaineConnexion)
   : base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(int? ID_listPlat, int? ID_typeRepa, DateTime R_Date)
  { return new A_T_repa(ChaineConnexion).Ajouter(ID_listPlat, ID_typeRepa , R_Date); }
  public int Modifier(int ID_repa, int? ID_listPlat, int? ID_typeRepa, DateTime R_Date)
  { return new A_T_repa(ChaineConnexion).Modifier(ID_repa, ID_listPlat, ID_typeRepa , R_Date); }
  public List<C_T_repa> Lire(string Index)
  { return new A_T_repa(ChaineConnexion).Lire(Index); }
    /// <summary>
    /// Permet de récupérer les repas entre deux date
    /// </summary>
    /// <param name="start">Date filtre debut compris</param>
    /// <param name="end">Date fin non compris</param>
    public List<C_T_repa> Lire(DateTime start, DateTime end)
    { return new A_T_repa(ChaineConnexion).Lire(start, end); }
    /// <summary>
    /// Permet de récupérer les repas d'une date donnée
    /// </summary>
    /// <param name="dateV">Date filtre</param>
    public List<C_T_plat> Lire(DateTime dateV)
    { return new A_T_repa(ChaineConnexion).Lire(dateV); }
  public C_T_repa Lire_ID(int ID_repa)
  { return new A_T_repa(ChaineConnexion).Lire_ID(ID_repa); }
  public int Supprimer(int ID_repa)
  { return new A_T_repa(ChaineConnexion).Supprimer(ID_repa); }
 }
}
